import java.io.*;
import org.xml.sax.*;
import com.docuverse.min.Parser;

public class MinBench extends BenchBase implements DocumentHandler {
    protected InputStream createInputStream() {
	return getClass().getResourceAsStream(filename);
    }

    protected void parse(InputStream s) throws Exception {
	elementCount = 0;
	attributeCount = 0;
	characterCount = 0;
	try {
	    Parser parser = new Parser();
	    parser.setDocumentHandler(this);
	    parser.parse(new InputSource(new InputStreamReader(s, encoding)));
	} finally {
	    if (s != null) {
		try {
		    s.close();
		} catch (Exception e) {}
	    }
	}
    }

    public void characters(char[] ch, int start, int length) {
	characterCount += length;
    }
    public void startElement(String name, AttributeList atts) {
	elementCount++;
	attributeCount += atts.getLength();
    }
    public void endElement(String name) {}
    public void startDocument() {}
    public void endDocument() {}
    public void ignorableWhitespace(char[] ch, int start, int length) {}
    public void processingInstruction(String target, String data) {}
    public void setDocumentLocator(Locator locator) {}
}
