import java.io.*;
import gd.xml.*;

public class TinyXMLBench extends BenchBase implements XMLResponder {
    protected InputStream createInputStream() {
	return getClass().getResourceAsStream(filename);
    }

    protected void parse(InputStream s) throws Exception {
	elementCount = 0;
	attributeCount = 0;
	characterCount = 0;
	try {
	    XMLParser parser = new XMLParser();
	    parser.parseXML(this);
	} finally {
	    if (s != null) {
		try {
		    s.close();
		} catch (Exception e) {}
	    }
	}
    }

    //// implements XMLResponder
    public InputStream getDocumentStream() throws ParseException {
	try {
	    return createInputStream();
	} catch(Exception e) {
	    throw new ParseException(e.getMessage());
	}
    }

    public void recordDocStart() {}
    public void recordDocEnd() {}
    public void recordDoctypeDeclaration(String name, String pubID,
					 String sysID) {}
    public void recordElementStart(String name, java.util.Hashtable attr) {
	elementCount++;
	if(attr != null) {
	    attributeCount += attr.size();
	}
    }
    public void recordElementEnd(String name) {}
    public void recordCharData(String charData) {
	//System.err.println(charData);
	characterCount += charData.length();
    }
    public void recordComment(String comment) {}
    public void recordPI(String name, String value) {}
    public InputStream resolveDTDEntity(String name, String pubID,
					String sysID) throws ParseException {
	return null;
    }
    public InputStream resolveExternalEntity(String name, String pubID,
					String sysID) throws ParseException {
	return null;
    }
    public void recordElementDeclaration(String name, String content) {}
    public void recordAttlistDeclaration(String element, String attr,
					 boolean notation, String type,
					 String defmod, String def) {
    }
    public void recordEntityDeclaration(String name, String value,
					String pubID, String sysID,
					String notation) {
    }
    public void recordNotationDeclaration(String name, String pubID,
					  String sysID) {
    }
}
